﻿'------------------------------------------------------
'Student Manager (Extended) created by Brandon Milton
'This project was explained in a video tutorial that was
'uploaded to: http://youtube.com/brandonioproductions
'This version if more complete, hence the "extended".

'Enjoy!
'Website: http://brandonsoft.com
'**********************************************************


Public Class Form1
    Private studentDatabase As Dictionary(Of Integer, Student)

    Private Sub Form1_FormClosing(sender As Object, e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        SaveStudents()
    End Sub

    Private Sub Form1_Load(sender As System.Object, e As System.EventArgs) Handles MyBase.Load
        studentDatabase = New Dictionary(Of Integer, Student)
        LoadStudents()
    End Sub

    Private Sub btn_add_Click(sender As System.Object, e As System.EventArgs) Handles btn_add.Click
        For Each c As Control In GroupBox1.Controls
            If (TypeOf c Is TextBox) Then
                Dim cText As TextBox = CType(c, TextBox)
                If (cText.Text.Equals("")) Then
                    MsgBox("All fields must be filled!")
                    Return
                End If
            End If
        Next

        'Continuation of sub
        If (btn_add.Text.Equals("Add Student")) Then
            'We want to add a student to the dictionary
            Dim studentToAdd As New Student(txt_studentFirstName.Text, txt_studentLastName.Text, txt_averageGradeLetter.Text)
            AddStudent(CInt(txt_studentID.Text), studentToAdd)
        ElseIf (btn_add.Text.Equals("Edit Student")) Then
            Dim studentToReplace As New Student(txt_studentFirstName.Text, txt_studentLastName.Text, txt_averageGradeLetter.Text)
            EditStudent(CInt(txt_studentID.Text), studentToReplace)

        End If
    End Sub

    Public Sub EditStudent(ByVal IDNumber As Integer, ByVal student As Student)
        studentDatabase.Remove(IDNumber)
        studentDatabase.Add(IDNumber, student)

        btn_add.Text = "Add Student"
        txt_studentID.Enabled = True
        RefreshListbox()
    End Sub

    Public Sub AddStudent(ByVal IDNumber As Integer, ByVal student As Student)
        If (studentDatabase.ContainsKey(IDNumber)) Then
            Dim studentToCheck As Student = studentDatabase.Item(IDNumber)
            Dim msgboxResult As DialogResult
            msgboxResult = MessageBox.Show("That ID Number already exists! It belongs to: " & studentToCheck.FirstName & " " & _
                                           studentToCheck.LastName & " Would you like to replace this student?", _
                                           "Replace?", MessageBoxButtons.YesNo)

            If (msgboxResult = Windows.Forms.DialogResult.Yes) Then
                'Replace the student
                studentDatabase.Remove(IDNumber)
                studentDatabase.Add(IDNumber, student)
            End If
        Else
            studentDatabase.Add(IDNumber, student)
        End If

        RefreshListbox()
    End Sub

    Public Sub DeleteStudent(ByVal IDNumber As Integer)
        studentDatabase.Remove(IDNumber)

        RefreshListbox()
    End Sub

    Public Sub LoadStudents()
        '1000000000: Bob Dylan (B)
        If (My.Computer.FileSystem.FileExists(My.Application.Info.DirectoryPath & "/students.dat")) Then
            Dim reader As New System.IO.StreamReader(My.Application.Info.DirectoryPath & "/students.dat")
            Dim readString As String = reader.ReadToEnd
            reader.Close()
            For Each entry As String In readString.Split(vbNewLine)
                If (entry.Contains(":")) Then
                    'Good to go.
                    Dim studentToAdd As New Student(entry.Split(":")(1).Split(" ")(1).ToString, entry.Split(":")(1).Split(" ")(2).ToString, _
                                                    entry.Split(":")(1).Split(" ")(3).ToString.Replace("(", "").Replace(")", ""))
                    AddStudent(CInt(entry.Split(":")(0).ToString), studentToAdd)
                End If
            Next
        End If
    End Sub

    Public Sub SaveStudents()
        Dim writer As New System.IO.StreamWriter(My.Application.Info.DirectoryPath & "/students.dat", False)
        Dim writeString As String = ""
        For Each item In lst_students.Items
            Dim text As String = item.ToString
            writeString = writeString & text & vbNewLine
        Next
        writer.Write(writeString)
        writer.Close()
    End Sub

    Public Sub RefreshListbox()
        lst_students.Items.Clear()
        '1000000000: Bob Dylan (B)
        For Each id As Integer In studentDatabase.Keys
            Dim student As Student = studentDatabase.Item(id)
            lst_students.Items.Add(id & ": " & student.FirstName & " " & student.LastName & _
                                   " (" & student.GradeLetter & ")")

        Next
    End Sub

    Private Sub btn_delete_Click(sender As System.Object, e As System.EventArgs) Handles btn_delete.Click
        If Not (lst_students.SelectedItem Is Nothing) Then
            Dim studentInformation As String = lst_students.SelectedItem.ToString
            Dim studentID As Integer = CInt(studentInformation.Split(":")(0))
            DeleteStudent(studentID)
        End If
    End Sub

    Private Sub btn_edit_Click(sender As System.Object, e As System.EventArgs) Handles btn_edit.Click
        '1000000000: Bob Dylan (B)
        If Not (lst_students.SelectedItem Is Nothing) Then
            Dim studentInformation As String = lst_students.SelectedItem.ToString
            txt_studentID.Text = studentInformation.Split(":")(0).ToString
            txt_studentID.Enabled = False
            txt_studentFirstName.Text = studentInformation.Split(":")(1).Split(" ")(1).ToString
            txt_studentLastName.Text = studentInformation.Split(":")(1).Split(" ")(2).ToString
            Dim averageGrade As String = studentInformation.Split(":")(1).Split(" ")(3)
            averageGrade = averageGrade.Replace("(", "")
            averageGrade = averageGrade.Replace(")", "")
            txt_averageGradeLetter.Text = averageGrade

            btn_add.Text = "Edit Student"
        End If
    End Sub
End Class
